
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ExpensesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const expenses = await db.expenses.create(
            {
                id: data.id || undefined,
        
        expense_number: data.expense_number
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        expense_type: data.expense_type
        ||
        null
            ,
            
        expense_date: data.expense_date
        ||
        null
            ,
            
        due_date: data.due_date
        ||
        null
            ,
            
        subtotal_amount: data.subtotal_amount
        ||
        null
            ,
            
        tax_amount: data.tax_amount
        ||
        null
            ,
            
        total_amount: data.total_amount
        ||
        null
            ,
            
        currency_code: data.currency_code
        ||
        null
            ,
            
        exchange_rate: data.exchange_rate
        ||
        null
            ,
            
        memo: data.memo
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await expenses.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await expenses.setVendor( data.vendor || null, {
            transaction,
        });
        
        await expenses.setTax_code( data.tax_code || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.expenses.getTableName(),
                belongsToColumn: 'receipt_files',
                belongsToId: expenses.id,
            },
            data.receipt_files,
            options,
        );
        

        return expenses;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const expensesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                expense_number: item.expense_number
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                expense_type: item.expense_type
            ||
            null
            ,
            
                expense_date: item.expense_date
            ||
            null
            ,
            
                due_date: item.due_date
            ||
            null
            ,
            
                subtotal_amount: item.subtotal_amount
            ||
            null
            ,
            
                tax_amount: item.tax_amount
            ||
            null
            ,
            
                total_amount: item.total_amount
            ||
            null
            ,
            
                currency_code: item.currency_code
            ||
            null
            ,
            
                exchange_rate: item.exchange_rate
            ||
            null
            ,
            
                memo: item.memo
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const expenses = await db.expenses.bulkCreate(expensesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < expenses.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.expenses.getTableName(),
                    belongsToColumn: 'receipt_files',
                    belongsToId: expenses[i].id,
                },
                data[i].receipt_files,
                options,
            );
        }
        

        return expenses;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const expenses = await db.expenses.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.expense_number !== undefined) updatePayload.expense_number = data.expense_number;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.expense_type !== undefined) updatePayload.expense_type = data.expense_type;
        
        
        if (data.expense_date !== undefined) updatePayload.expense_date = data.expense_date;
        
        
        if (data.due_date !== undefined) updatePayload.due_date = data.due_date;
        
        
        if (data.subtotal_amount !== undefined) updatePayload.subtotal_amount = data.subtotal_amount;
        
        
        if (data.tax_amount !== undefined) updatePayload.tax_amount = data.tax_amount;
        
        
        if (data.total_amount !== undefined) updatePayload.total_amount = data.total_amount;
        
        
        if (data.currency_code !== undefined) updatePayload.currency_code = data.currency_code;
        
        
        if (data.exchange_rate !== undefined) updatePayload.exchange_rate = data.exchange_rate;
        
        
        if (data.memo !== undefined) updatePayload.memo = data.memo;
        
        
        updatePayload.updatedById = currentUser.id;

        await expenses.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await expenses.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.vendor !== undefined) {
            await expenses.setVendor(
              
              data.vendor,
              
              { transaction }
            );
        }
        
        if (data.tax_code !== undefined) {
            await expenses.setTax_code(
              
              data.tax_code,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.expenses.getTableName(),
                belongsToColumn: 'receipt_files',
                belongsToId: expenses.id,
            },
            data.receipt_files,
            options,
        );
        

        return expenses;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const expenses = await db.expenses.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of expenses) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of expenses) {
                await record.destroy({transaction});
            }
        });


        return expenses;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const expenses = await db.expenses.findByPk(id, options);

        await expenses.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await expenses.destroy({
            transaction
        });

        return expenses;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const expenses = await db.expenses.findOne(
            { where },
            { transaction },
        );

        if (!expenses) {
            return expenses;
        }

        const output = expenses.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await expenses.getOrganization({
            transaction
        });
        
        
        output.vendor = await expenses.getVendor({
            transaction
        });
        
        
        output.tax_code = await expenses.getTax_code({
            transaction
        });
        
        
        output.receipt_files = await expenses.getReceipt_files({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.contacts,
        as: 'vendor',
        
        where: filter.vendor ? {
          [Op.or]: [
            { id: { [Op.in]: filter.vendor.split('|').map(term => Utils.uuid(term)) } },
            {
              display_name: {
                [Op.or]: filter.vendor.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.tax_codes,
        as: 'tax_code',
        
        where: filter.tax_code ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tax_code.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tax_code.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'receipt_files',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.expense_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'expenses',
                        'expense_number',
                        filter.expense_number,
                    ),
                };
            }
            
            if (filter.currency_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'expenses',
                        'currency_code',
                        filter.currency_code,
                    ),
                };
            }
            
            if (filter.memo) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'expenses',
                        'memo',
                        filter.memo,
                    ),
                };
            }
            

            
            

            
            if (filter.expense_dateRange) {
                const [start, end] = filter.expense_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expense_date: {
                    ...where.expense_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expense_date: {
                    ...where.expense_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.due_dateRange) {
                const [start, end] = filter.due_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    due_date: {
                    ...where.due_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    due_date: {
                    ...where.due_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.subtotal_amountRange) {
                const [start, end] = filter.subtotal_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    subtotal_amount: {
                    ...where.subtotal_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    subtotal_amount: {
                    ...where.subtotal_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.tax_amountRange) {
                const [start, end] = filter.tax_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    tax_amount: {
                    ...where.tax_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    tax_amount: {
                    ...where.tax_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.total_amountRange) {
                const [start, end] = filter.total_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    total_amount: {
                    ...where.total_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    total_amount: {
                    ...where.total_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.exchange_rateRange) {
                const [start, end] = filter.exchange_rateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    exchange_rate: {
                    ...where.exchange_rate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    exchange_rate: {
                    ...where.exchange_rate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.expense_type) {
                where = {
                    ...where,
                expense_type: filter.expense_type,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.expenses.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'expenses',
                        'expense_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.expenses.findAll({
            attributes: [ 'id', 'expense_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['expense_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.expense_number,
        }));
    }

    
};

